--[[
Quest Status:
-1 = Failed, Abandoned
0 = In Progress
1 = Completed
2 = Turned In

Rock("LibRockConfig-1.0").OpenConfigMenu(EveryQuest)
--]]

local EveryQuest, self = EveryQuest, EveryQuest
local EveryQuestQ, EveryQuestQ = EveryQuestQ, EveryQuestQ
local EveryQuestdewdrop = AceLibrary("Dewdrop-2.0")
local L = AceLibrary("AceLocale-2.2"):new("EveryQuest")
local questdisplay = {}
local SECOND = 1
local MINUTE = 60
local HOUR = 3600
local DAY = 86400
local clickedID
local EveryQuestItemList = {
	type = 'group',
	args = {
		updatestatus = {
			type = 'group',
			name = L["Change Status"],
			desc = L["Change Status"],
			args = {
				turnedin = {
					type = 'toggle',
					name = L["Turned In"],
					desc = L["Turned In"],
					get = function() if EveryQuest:GetStatus(clickedID, 2) then return true else return false end end,
					set = function() EveryQuest:UpdateStatus(clickedID, 2) end,
				},
				completed = {
					type = 'toggle',
					name = L["Completed"],
					desc = L["Completed"],
					get = function() if EveryQuest:GetStatus(clickedID, 1) then return true else return false end end,
					set = function() EveryQuest:UpdateStatus(clickedID, 1) end,
				},
				inprogress = {
					type = 'toggle',
					name = L["In Progress"],
					desc = L["In Progress"],
					get = function() if EveryQuest:GetStatus(clickedID, 0) then return true else return false end end,
					set = function() EveryQuest:UpdateStatus(clickedID, 0) end,
				},
				abandoned = {
					type = 'toggle',
					name = L["Abandoned"],
					desc = L["Abandoned"],
					get = function() if EveryQuest:GetStatus(clickedID, -1) then return true else return false end end,
					set = function() EveryQuest:UpdateStatus(clickedID, -1) end,
				},
				failed = {
					type = 'toggle',
					name = L["Failed"],
					desc = L["Failed"],
					get = function() if EveryQuest:GetStatus(clickedID, -1) then return true else return false end end,
					set = function() EveryQuest:UpdateStatus(clickedID, -1) end,
				},
			},
		},
		close = {
			type = 'execute',
			name = L["Close"],
			desc = L["Close"],
			func = function() EveryQuestdewdrop:Close() end,
		},
	},
}
local zones = {
	["Outland"] = {
		["Blade's Edge Mountains"] = true,
		["Hellfire Peninsula"] = true,
		["Nagrand"] = true,
		["Netherstorm"] = true,
		["Shadowmoon Valley"] = true,
		["Shattrath City"] = true,
		["Terokkar Forest"] = true,
		["Zangarmarsh"] = true,
	},
	["Dungeons"] = {
		["Auchenai Crypts"] = true,
		["Auchindoun"] = true,
		["Caverns of Time"] = true,
		--["Coilfang Reservoir"] = true,
		["Hellfire Citadel"] = true,
		["Mana-Tombs"] = true,
		--["Tempest Keep"] = true,
		["The Slave Pens"] = true,
		["The Steamvault"] = true,
		["Shadow Labyrinth"] = true,
		--["Sethekk Halls"] = true,
		--["Hellfire Ramparts"] = true,
		--["The Blood Furnace"] = true,
		--["The Shattered Halls"] = true,
		["The Underbog"] = true,
		--["The Mechanar"] = true,
		--["The Botanica"] = true,
		--["The Arcatraz"] = true,
		--["Old Hillsbrad Foothills"] = true,
		--["The Black Morass"] = true,
	},
	["Raids"] = {
		["Karazhan"] = true,
		["Magtheridon's Lair"] = true,
		["Hyjal Summit"] = true,
		["Serpentshrine Cavern"] = true,
		["Zul'Aman"] = true,
		["The Eye"] = true,
		--["Gruul's Lair"] = true,
		["The Black Temple"] = true,
	},
}
function EveryQuest:EveryQuestInit()
	-- Register Events
	self:RegisterEvent("QUEST_PROGRESS")
	--self:RegisterEvent("QUEST_COMPLETE")
    self:RegisterEvent("Quixote_Quest_Complete")
	self:RegisterEvent("Quixote_Quest_Failed")
	self:RegisterEvent("Quixote_Quest_Gained")
	
	-- fuax self:RegisterEvent("ABANDON_QUEST")
	StaticPopupDialogs["ABANDON_QUEST"].OnAccept = function() EveryQuest:QUEST_ABANDON(GetAbandonQuestName()) AbandonQuest(); PlaySound("igQuestLogAbandonQuest"); end
	StaticPopupDialogs["ABANDON_QUEST_WITH_ITEMS"].OnAccept = function() EveryQuest:QUEST_ABANDON(GetAbandonQuestName()) AbandonQuest(); PlaySound("igQuestLogAbandonQuest"); end

	-- Hooks
	QuestFrameCompleteQuestButton:SetScript("OnClick", function() EveryQuest:Hooks_QuestCompleted() end)
	--self:Hook("QuestFrameCompleteQuestButton_OnClick", "Hooks_QuestCompleted", true)
	
	EveryQuestTitleText:SetText(L["EveryQuest Log"])
	
	-- Zone Menu creation
	EveryQuest.ZoneListMenu = CreateFrame("Frame", "EveryQuestdewdropZoneListMenu", EveryQuestFrame, "UIDropDownMenuTemplate")
	EveryQuest.ZoneListMenu:Show()
	EveryQuest.ZoneListMenu:ClearAllPoints()
	EveryQuest.ZoneListMenu:SetPoint("TOPLEFT",EveryQuestFrame, "TOPLEFT", 115,-40)
	UIDropDownMenu_SetWidth(150, EveryQuestdewdropZoneListMenu)
	UIDropDownMenu_SetButtonWidth(20, EveryQuestdewdropZoneListMenu)
	EveryQuestdewdropZoneListMenuButton:SetScript("OnClick", function() if EveryQuestdewdrop:IsOpen() then EveryQuestdewdrop:Close() else EveryQuestdewdrop:Open(EveryQuest.zonemenuloc) end end)
	
	EveryQuest.zonemenuloc = CreateFrame("Frame", nil, EveryQuestFrame)
	EveryQuest.zonemenuloc:SetWidth(2)
	EveryQuest.zonemenuloc:SetHeight(2)
	EveryQuest.zonemenuloc:ClearAllPoints()
	EveryQuest.zonemenuloc:SetPoint("BOTTOMRIGHT", EveryQuestdewdropZoneListMenuButton)
	
	
	EveryQuest.EveryQuestToggleButton = CreateFrame("Button",nil, QuestLogFrame, "UIPanelButtonTemplate")
	EveryQuest.EveryQuestToggleButton:SetWidth(28)
	EveryQuest.EveryQuestToggleButton:SetHeight(18)
	EveryQuest.EveryQuestToggleButton:SetText("EQ")
	EveryQuest.EveryQuestToggleButton:Show()
	EveryQuest.EveryQuestToggleButton:ClearAllPoints()
	
	EveryQuest.ListToggleButton = CreateFrame("Button",EveryQuestListToggleButton, EveryQuestFrame, "UIPanelButtonTemplate")
	EveryQuest.ListToggleButton:SetWidth(122)
	EveryQuest.ListToggleButton:SetHeight(21)
	EveryQuest.ListToggleButton:SetText(" ")
	EveryQuest.ListToggleButton:Show()
	EveryQuest.ListToggleButton:ClearAllPoints()
	EveryQuest.ListToggleButton:SetPoint("BOTTOMLEFT",EveryQuestFrame, "BOTTOMLEFT",18,5)
	EveryQuest.ListToggleButton:SetScript("OnClick", function() EveryQuest:ListToggle() end)
	
	if not IsAddOnLoaded("beql") then
		EveryQuest.EveryQuestToggleButton:SetPoint("TOPLEFT",QuestLogFrame, "TOPLEFT",72,-15)
	else
		EveryQuest.EveryQuestToggleButton:SetPoint("TOPLEFT",QuestLogFrame, "TOPLEFT",75,-15)
	end
	EveryQuest.EveryQuestToggleButton:SetScript("OnClick", function() EveryQuest:EveryQuestToggle()	end)
	
	BINDING_HEADER_eqTITLE = L["EveryQuest"]
	BINDING_NAME_eqTOGGLE = L["Toggle Frame"]
	
	local info = {
		type = 'group',
		args = {},
	}
	
	UIDropDownMenu_SetText(L["-- Select --"], EveryQuestdewdropZoneListMenu)
	
	local i, j = 0, 0
	for k, v in pairs (zones) do 
		i = i +1
		info.args[i] = {
			type = 'group',
			name = k,
			desc = k,
			order = 1,
			args = {}
		}
		for zk, zv in pairs (zones[k]) do
			j = j +1
			info.args[i].args[j] = {
				type = 'toggle',
				name = zk,
				desc = zk,
				get = function() if EveryQuestdewdrop.value == zk then return true else return false end end,
				set = function() EveryQuestdewdrop.value = zk EveryQuestdewdrop.group = k UIDropDownMenu_SetText(zk, EveryQuestdewdropZoneListMenu) EveryQuestdewdrop:Close() EveryQuest:ListToggle(false) end,
			}
		end
		j = 0
	end
	info.args[i+1] = {
			type = 'execute',
			name = L["Close"],
			desc = L["Close"],
			order = 10,
			func = function() EveryQuestdewdrop:Close() end,
		}
	EveryQuestdewdrop:Register(EveryQuest.zonemenuloc, 'children', function() EveryQuestdewdrop:FeedAceOptionsTable(info) end)
	local button = CreateFrame("Button", "EveryQuestTitle1", EveryQuestFrame,"EveryQuestTitleButtonTemplate")
	button:SetID(1)
	button:Hide()
	button:ClearAllPoints()
	button:SetPoint("TOPLEFT", EveryQuestFrame, "BOTTOMLEFT", 19, -75)
	for i = 2, 27 do
		button = CreateFrame("Button", "EveryQuestTitle" .. i, EveryQuestFrame,"EveryQuestTitleButtonTemplate")
		button:SetID(i)
		button:Hide()
		button:ClearAllPoints()
		button:SetPoint("TOPLEFT", getglobal("EveryQuestTitle" .. (i-1)), "BOTTOMLEFT", 0, 1)
	end
	EveryQuestFrame:SetScale(QuestLogFrame:GetScale())
	EveryQuest:ListToggle(EveryQuest.db.profile.showall)
end

function EveryQuest:EveryQuestToggle()
	if EveryQuestFrame:IsShown() then
		EveryQuestFrame:Hide()
	else
		EveryQuestFrame:Show()	
	end
end

function EveryQuest:EveryQuestSavePosition()
	local Left = EveryQuestFrame:GetLeft()
	local Top = EveryQuestFrame:GetTop()
	if Left and Top then
		EveryQuest.db.char.saved.eqlogposx = Left
		EveryQuest.db.char.saved.eqlogposy = Top
	end
end

function EveryQuest_OnShow()
	if EveryQuest.db.char.saved.eqlogposx and EveryQuest.db.char.saved.eqlogposy then
		EveryQuestFrame:ClearAllPoints()
		EveryQuestFrame:SetPoint("TOPLEFT","UIParent", "BOTTOMLEFT", EveryQuest.db.char.saved.eqlogposx, EveryQuest.db.char.saved.eqlogposy)
	end
end

function EveryQuest:NewZone()
	EveryQuestListScrollFrame:SetVerticalScroll(0)
	EveryQuest:EveryQuestUpdate()
end

---------------------------------------------------------------------------------------------------------------------------- 

function EveryQuest:EveryQuestUpdate()

	local questIndex
	local questHistory
	
	local i,k,v
	local ListFrame
	local r,g,b
	local qTag
	local qTitle
	local scrolloffset
	local isCollapsed
	local i = 1
	local controli = 0
	
	if not EveryQuest.db.profile.showall then
		questzone = EveryQuestdewdrop.value
		questlist = getglobal(EveryQuest:LoadQuestData())
		--if EveryQuest.db.profile.debug then self:Print("EveryQuestUpdate(questlist = questlist[EveryQuestdewdrop.value])") end
	else
		questlist = EveryQuest.db.char.QuestHistory
		--if EveryQuest.db.profile.debug then self:Print("EveryQuestUpdate(questlist = EveryQuest.db.char.QuestHistory)") end
	end
	
	FauxScrollFrame_Update(EveryQuestListScrollFrame,EveryQuest:GetEveryQuestCount(),27,16)
	scrollofset = FauxScrollFrame_GetOffset(EveryQuestListScrollFrame)
	
	-- Print the Zones
		-- Print the Quests in the Zone
	if questlist then
		if not EveryQuest.db.profile.showall then
			if questzone ~= nil and questlist[questzone] then
				--if EveryQuest.db.profile.debug then self:Print("EveryQuestUpdate(showing zone)") end
				for j, l in pairs (questlist[questzone]) do
					controli = controli + 1
					if controli > scrollofset then
						if i > 27 then 
							break 
						end
						--if EveryQuest.db.profile.debug then self:Print("UpdateFrame("..i..", "..j..", "..questzone..")") end
						EveryQuest:UpdateFrame(i, l, questzone, j)
						i = i +1		
					end
				end
			end
		else
			--if EveryQuest.db.profile.debug then self:Print("EveryQuestUpdate(showing questhistory)") end
			-- show the whole list
			for k, v in pairs (questlist) do
				-- Print the Zones
				questzone = k
				controli = controli + 1
				if controli > scrollofset then
					if i > 27 then 
						break 
					end
					if not questdisplay[i] then questdisplay[i] = {} end
					ListFrame = getglobal("EveryQuestTitle"..i)
					ListFrame:SetText(questzone)
					if questlist[questzone].Collapsed then questdisplay[i].Name = "Collapsed" else questdisplay[i].Name = k end
					questdisplay[i].Zone = questzone
					ListFrame:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
					ListFrame:Show()
					i = i +1
					if  questlist[questzone].Collapsed  then
						ListFrame:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
					else
						ListFrame:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up"); 
					end					
				end
				-- Print the Quests in the Zone
				if not questlist[questzone].Collapsed then
					for j, l in pairs (questlist[questzone]) do
						if j ~= "Collapsed" then
							controli = controli + 1
							if controli > scrollofset then
								if i > 27 then 
									break 
								end
								EveryQuest:UpdateFrame(i, l, questzone, j)
								i = i +1		
							end
						end
					end
				end -- j, l
			end -- k, v
		end -- showall
	end -- if quests
		
	--Clean Up unused ID's
	for j = i, 27 ,1 do
		ListFrame = getglobal("EveryQuestTitle"..j)
		ListFrame:Hide()
	end
	
end

function EveryQuest:UpdateFrame(id, questtable, questzone, listid)
	if questtitle ~= "Collapsed" and EveryQuest.db.profile.showall or not EveryQuest.db.profile.showall then
		if EveryQuest.db.profile.showall then
			questname = listid
		else
			questname = questtable.Name
		end
		ListFrame = getglobal("EveryQuestTitle"..id)
		ListFrame:SetNormalTexture("")
		ListFrame:SetText("")
		if not questdisplay[id] then questdisplay[id] = {} end
		questdisplay[id].Name = questname
		questdisplay[id].Zone = questzone
		questdisplay[id].Id = listid
		if questtable.Tag then
			qTag = string.upper(questtable.Tag)
		else
			qTag = ""
		end
		ListFrame:SetText("["..questtable.Level..qTag.."] "..questname)
		--r,g,b = EveryQuest:GetQuestColor(zonelist.value, j)
		if EveryQuest.db.char.QuestHistory[questzone] and EveryQuest.db.char.QuestHistory[questzone][questname] then
			questHistory = EveryQuest.db.char.QuestHistory[questzone][questname]
			if questHistory["status"] == 1 then
				ListFrame:SetTextColor(0,1,0)
			elseif questHistory["status"] == -1 then
				ListFrame:SetTextColor(1,0,0)
			elseif questHistory["status"] == 2 then
				ListFrame:SetTextColor(0,.807,.019)
			elseif questHistory["status"] == 0 then
				ListFrame:SetTextColor(1,1,0)
			elseif not questHistory["status"] then
				ListFrame:SetTextColor(1,1,1)
			elseif questHistory["status"] == nil then
				ListFrame:SetTextColor(1,1,1)
			end
		else
			ListFrame:SetTextColor(1,1,1)
		end
		--ListFrame:SetTextColor(r,g,b) --ListFrame:SetTextColor(GetDifficultyColor(questHistory[j].Level).r,GetDifficultyColor(questHistory[j].Level).g,GetDifficultyColor(questHistory[j].Level).b)
		ListFrame:Show()
	end
end

function EveryQuest:EveryQuestTitleClick(button)
	clickedID = this:GetID()
	if questdisplay[clickedID].Name ~= "Collapsed" and questdisplay[clickedID].Name ~= questdisplay[clickedID].Zone then
		if button == "LeftButton" then
			-- open lightheaded if enabled
			if IsAddOnLoaded("Lightheaded") then
				if IsAddOnLoaded("beql") then
					beql:Minimize()
				end
				QuestLogFrame:Show()
				LightHeaded:UpdateFrame(questdisplay[clickedID].Name, questlist[questdisplay[clickedID].Zone][questdisplay[clickedID].Id].Level, 1)
				QuestLogFrame:ClearAllPoints()
				QuestLogFrame:SetPoint("TOPLEFT",EveryQuestFrame, "TOPLEFT", 360, 0)
			end
		elseif button == "RightButton" then
			-- open quest menu
			if not ddframe then
					ddframe = CreateFrame("Frame", nil, UIParent)
					ddframe:SetWidth(2)
					ddframe:SetHeight(2)
					ddframe:SetPoint("BOTTOMLEFT", GetCursorPosition())
					ddframe:SetClampedToScreen(true)
					EveryQuestdewdrop:Register(ddframe, 'dontHook', true, 'children', function() EveryQuestdewdrop:FeedAceOptionsTable(EveryQuestItemList) end)
			end
			local x,y = GetCursorPosition()
			ddframe:SetPoint("BOTTOMLEFT", x / UIParent:GetScale(), y / UIParent:GetScale())
			EveryQuestdewdrop:Open(ddframe)
		end
	else
		if button == "LeftButton" then
			if not EveryQuest.db.char.QuestHistory[questdisplay[clickedID].Zone].Collapsed then
				EveryQuest.db.char.QuestHistory[questdisplay[clickedID].Zone].Collapsed = true
			else
				EveryQuest.db.char.QuestHistory[questdisplay[clickedID].Zone].Collapsed = false
			end
			--EveryQuest.db.char.QuestHistory[questzone].Collapsed = not questlist[questzone].Collapsed
			EveryQuest:EveryQuestUpdate()
			--if EveryQuest.db.profile.debug then self:Print("EveryQuestTitleClick("..EveryQuest.db.char.QuestHistory[questdisplay[clickedID].Zone].Collapsed..")") end
		end
	end
end


function EveryQuest:GetEveryQuestCount()
	local k,v,j,l
	--local debugg
	local n = 0
	if not EveryQuest.db.profile.showall then
		--debugg = "showall"
		if questlist and questlist[questzone] then
			for k, v in pairs (questlist[questzone]) do
				n = n +1
			end
		end
	else
		--debugg = "else"
		for k, v in pairs (EveryQuest.db.char.QuestHistory) do
			n = n +1
			if not EveryQuest.db.char.QuestHistory[k].Collapsed then
				for j, l in pairs (EveryQuest.db.char.QuestHistory[k]) do
					if j ~= "Collapsed" then
						n = n +1
					end
				end
			end
		end
	end
	--if EveryQuest.db.profile.debug then self:Print("EveryQuest:GetEveryQuestCount("..n..") - "..debugg) end
	return n
end

function EveryQuest_ScrollFrame_Update()
	EveryQuest:EveryQuestUpdate()
end

function EveryQuest:EveryQuestAddQuest(questid)
	if EveryQuest.db.char.QuestHistory == nil then
		EveryQuest.db.char.QuestHistory = {} 
	end
	if questid then
		local qtitle, qlevel, qtag, qgroup, qstatus, _, zone = EveryQuestQ:GetQuestById(questid)
		if EveryQuest.db.char.QuestHistory[zone] == nil then
			EveryQuest.db.char.QuestHistory[zone] = {}
		end
		if EveryQuest.db.char.QuestHistory[zone][qtitle] == nil then
			EveryQuest.db.char.QuestHistory[zone][qtitle] = {}
			EveryQuest.db.char.QuestHistory[zone][qtitle].status = qstatus
		end
		EveryQuest.db.char.QuestHistory[zone][qtitle].Level = qlevel
		EveryQuest.db.char.QuestHistory[zone][qtitle].Tag = qtag
		if qtag == "y" then 
			EveryQuest.db.char.QuestHistory[zone][qtitle].Daily = true
		else
			EveryQuest.db.char.QuestHistory[zone][qtitle].Daily = false
		end
	end
end

function EveryQuest:Hooks_QuestCompleted()
	if ( QuestFrameRewardPanel.itemChoice == 0 and GetNumQuestChoices() > 0 ) then
		QuestChooseRewardError();
	else
		EveryQuest:QuestTurnedIn(GetTitleText())
		GetQuestReward(QuestFrameRewardPanel.itemChoice);
		PlaySound("igQuestListComplete");
	end
end

function EveryQuest:QuestTurnedIn(questName)
	local qtitle, _, _, _, _, _, zone, questid = EveryQuestQ:GetQuestByName(questName)
	-- QuestHistory: Update Status: Quest completed, add completed timestamp
	if questid then
		EveryQuest:EveryQuestAddQuest(questid)
		EveryQuest.db.char.QuestHistory[zone][qtitle].status = 2
		EveryQuest.db.char.QuestHistory[zone][qtitle].completed = time()
	end
end

function EveryQuest:LoadQuestData()
	local questtype
	if EveryQuestdewdrop.group ~= nil then
		if EveryQuestdewdrop.group ~= "Outland" then
			questtype = "Instance"
		else
			questtype = "Outland"
		end
		local faction = UnitFactionGroup("player")
		local varname = "EveryQuest_"..faction:sub(1,1)..questtype.."_Data" --beql_AOutland_Data
		--local addonname = ("EveryQuest__%s%s_Data"):format(faction:sub(1,1), questtype)
		local _, _, _, enabled = GetAddOnInfo(varname)
		--if questdata and questdata[varname] then return varname end
		
		if not getglobal(varname) then
			if enabled then
				EveryQuest:Print(L["Loading "] .. varname)
				local succ,reason = LoadAddOn(varname)
				if succ ~= 1 then
					EveryQuest:Print(L["Could not load "] .. varname, reason)
				end
				collectgarbage("collect")
			else
				EveryQuest:Print(L["Requires LOD Module: "] .. varname)
			end
		end
		
		--questdata[varname] = getglobal(varname)
		return varname --questdata[varname] and varname
	end
end

function EveryQuest:EveryQuestTitleEnter()
	local index = this:GetID()
	local isCollected
	local questLogTitleText = questdisplay[index].Name
	local questzone = questdisplay[index].Zone
	if questdisplay[index].Name ~= "Collapsed" and questzone ~= questLogTitleText then
		GameTooltip_SetDefaultAnchor(GameTooltip, this)
		GameTooltip:SetText(questLogTitleText)
		local queststatus = "Unknown"
		if EveryQuest.db.char.QuestHistory[questzone] and EveryQuest.db.char.QuestHistory[questzone][questLogTitleText] then
			isCollected = true
			if EveryQuest.db.char.QuestHistory[questzone][questLogTitleText].status then
				queststatus = EveryQuest.db.char.QuestHistory[questzone][questLogTitleText].status
				if queststatus == -1 then
					queststatus = L["Failed or Abandoned"]
					
				elseif queststatus == 0 then
					queststatus = L["In Progress"]
				elseif queststatus == 1 then
					queststatus = L["Completed"]
				elseif queststatus == 2 then
					queststatus = L["Turned In"]
				end
			end
		end
		GameTooltip:AddLine("Status: " .. queststatus,1,1,1)
		if isCollected then
			if EveryQuest.db.char.QuestHistory[questzone][questLogTitleText].failed then
				GameTooltip:AddLine(L["Failed: "] .. EveryQuest:timeDiff(EveryQuest.db.char.QuestHistory[questzone][questLogTitleText].failed),1,1,1)
			end
			if EveryQuest.db.char.QuestHistory[questzone][questLogTitleText].abandoned then
				GameTooltip:AddLine(L["Abandoned: "] .. EveryQuest:timeDiff(EveryQuest.db.char.QuestHistory[questzone][questLogTitleText].abandoned),1,1,1)
			end
			if EveryQuest.db.char.QuestHistory[questzone][questLogTitleText].completed then
				GameTooltip:AddLine(L["Completed: "] .. EveryQuest:timeDiff(EveryQuest.db.char.QuestHistory[questzone][questLogTitleText].completed),1,1,1)
			end
		end
		GameTooltip:Show()
	end
end

function EveryQuest:timeDiff(timestamp)
    local now = time()
	local amount = now - timestamp
	local value
	local seconds, minutes, hours, days
    --If the difference is positive "ago" - negative "away"

	--amount = amount + DAY + HOUR*5
	
	if amount >= (DAY * 10) then
		return date("%m/%d/%y %I%p", timestamp)
	end
	
	if (amount >= DAY) and (amount < (DAY * 10)) then
		-- between one day and 30 days
		days = math.floor(amount/DAY)
		if days ~= 1 then days = days .. L[" days "] else days = days .. L[" day "] end
		hours = amount%DAY
		hours = math.floor(hours/HOUR)
		if hours ~= 0 then hours = hours .. L[" hr "] else hours = "" end
		return days .. hours .. L["ago"]
		--return "between one day and 30 days"
	end
  
	if (amount < DAY) and (amount >= HOUR) then
		-- between one hour and one day
		--value = string.format("%H hr %M min ago", amount)
		hours = math.floor(amount/HOUR)
		minutes = amount%HOUR
		minutes = math.floor(minutes/MINUTE +.5)
		if minutes ~= 0 then minutes = minutes .. L[" min "] else minutes = "" end
		return hours .. L[" hr "] .. minutes .. L["ago"]
		--return  .. " between one hour and one day"
	end
	
	if (amount < HOUR and amount >= MINUTE) then
		-- between one minute and one hour
		if EveryQuest:round(amount / MINUTE) > 1 then
			return EveryQuest:round(amount / MINUTE) .. L[" minutes ago"]
		else
			return L["1 minute ago"]
		end
	end
	
	if amount > 1 then
		return amount .. L[" seconds ago"]
	else
		return amount .. L[" second ago"]
	end
end

function EveryQuest:round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

function EveryQuest:UpdateStatus(displayid, queststatus)
	--questdisplay[displayid]
	local questtitle = questdisplay[displayid].Name
	local questzone = questdisplay[displayid].Zone
	local questid = questdisplay[displayid].Id
	if not EveryQuest.db.char.QuestHistory[questzone] then
		EveryQuest.db.char.QuestHistory[questzone] = {}
	end
	if not EveryQuest.db.char.QuestHistory[questzone][questtitle] then
		EveryQuest.db.char.QuestHistory[questzone][questtitle] = {}
		EveryQuest.db.char.QuestHistory[questzone][questtitle].Level = questlist[questzone][questid].Level
		EveryQuest.db.char.QuestHistory[questzone][questtitle].Tag = questlist[questzone][questid].Tag
		EveryQuest.db.char.QuestHistory[questzone][questtitle].Daily = questlist[questzone][questid].Daily
	end
	EveryQuest.db.char.QuestHistory[questzone][questtitle].status = queststatus
	EveryQuest:EveryQuestUpdate()
end

function EveryQuest:GetStatus(displayid, queststatus)
	local questtitle = questdisplay[displayid].Name
	local questzone = questdisplay[displayid].Zone
	if EveryQuest.db.char.QuestHistory[questzone] and EveryQuest.db.char.QuestHistory[questzone][questtitle] and EveryQuest.db.char.QuestHistory[questzone][questtitle].status then
		if EveryQuest.db.char.QuestHistory[questzone][questtitle].status == queststatus then
			return true
		else
			return false
		end
	else
		return false
	end
end

function EveryQuest:Quixote_Quest_Complete(questname, questid)
	-- QuestHistory: Update Status: Quest Finished, not turned in
	EveryQuest:EveryQuestAddQuest(questid)
	local qtitle, _, _, _, _, _, zone = EveryQuestQ:GetQuestById(questid)
	EveryQuest.db.char.QuestHistory[zone][qtitle].status = 1
	if EveryQuest.db.profile.debug then self:Print("EveryQuest:Quixote_Quest_Complete(" .. questid .. "), status:"..EveryQuest.db.char.QuestHistory[zone][qtitle].status) end
end

function EveryQuest:Quixote_Quest_Gained(questname, questid, numObjectives)
	-- QuestHistory: Add Quest to history, update Status: In Progress
	EveryQuest:EveryQuestAddQuest(questid)
	local qtitle, _, _, _, _, _, zone = EveryQuestQ:GetQuestById(questid)
	EveryQuest.db.char.QuestHistory[zone][qtitle].status = 0
	if EveryQuest.db.profile.debug then  self:Print("EveryQuest:Quixote_Quest_Gained(" .. questid .. "), status:"..EveryQuest.db.char.QuestHistory[zone][qtitle].status) end
end

function EveryQuest:Quixote_Quest_Failed(questname, questid)
	-- QuestHistory: Update Status: Failed, failed counter +1
	EveryQuest:EveryQuestAddQuest(questid)
	local qtitle, _, _, _, _, _, zone = EveryQuestQ:GetQuestById(questid)
	EveryQuest.db.char.QuestHistory[zone][qtitle].status = -1
	EveryQuest.db.char.QuestHistory[zone][qtitle].failed = time()
	if EveryQuest.db.profile.debug then self:Print("EveryQuest:Quixote_Quest_Failed(" .. questid .. "), status:"..EveryQuest.db.char.QuestHistory[zone][qtitle].status) end
end

function EveryQuest:QUEST_ABANDON(questName)
	if EveryQuest.db.profile.debug then self:Print("QUEST_ABANDON") end
	local qtitle, _, _, _, _, _, zone, questid = EveryQuestQ:GetQuestByName(questName)
	if questid then
		EveryQuest:EveryQuestAddQuest(questid)
		EveryQuest.db.char.QuestHistory[zone][qtitle].status = -1
		EveryQuest.db.char.QuestHistory[zone][qtitle].abandoned = time()
	end
end

function EveryQuest:QUEST_PROGRESS()
	if EveryQuest.db.profile.debug then self:Print("QUEST_PROGRESS") end
	local questtitle = GetTitleText()
	local _, _, _, _, _, _, _, questid = EveryQuestQ:GetQuestByName(questtitle)
	if questid then
		EveryQuest:EveryQuestAddQuest(questid)
	end
end

function EveryQuest:ListToggle(value)
	if value ~= nil then
		if value == true then
			EveryQuest.db.profile.showall = true
			EveryQuestCollapseAllButton:Show()
			if EveryQuest.db.profile.debug then self:Print("EveryQuest:ListToggle(true)") end
			EveryQuest.ListToggleButton:SetText("Show Zone Quests")
			EveryQuest:NewZone()
		elseif value == false then
			EveryQuestCollapseAllButton:Hide()
			EveryQuest.db.profile.showall = false
			if EveryQuest.db.profile.debug then self:Print("EveryQuest:ListToggle(false)") end
			EveryQuest.ListToggleButton:SetText("Show Quest History")
			EveryQuest:NewZone()
		end
	else
		if EveryQuest.db.profile.showall == false then
			EveryQuest.db.profile.showall = true
			EveryQuestCollapseAllButton:Show()
			if EveryQuest.db.profile.debug then self:Print("EveryQuest:ListToggle(true)") end
			EveryQuest.ListToggleButton:SetText("Show Zone Quests")
			EveryQuest:NewZone()
		elseif EveryQuest.db.profile.showall == true then
			EveryQuestCollapseAllButton:Hide()
			EveryQuest.db.profile.showall = false
			if EveryQuest.db.profile.debug then self:Print("EveryQuest:ListToggle(false)") end
			EveryQuest.ListToggleButton:SetText("Show Quest History")
			EveryQuest:NewZone()
		end
	end
end

function EveryQuest:CollapseAllButton()

end
